; ***********************************************************************
; ***********************************************************************
; *                                                                     *
; *                    Background Bitmap Functions                      *
; *                                                                     *
; ***********************************************************************
; ***********************************************************************

.386p 
.model flat 
.code 
include Gb.Inc

Ext_BMP equ     ('b')+('m'*256)+('p'*65536)

; ***********************************************************************
; *                                                                     *
; *                  Load the default bitmap in                         *
; *                                                                     *
; ***********************************************************************

LoadBitmap Proc
        mov     edx,offset DefaultBitmap
        mov     esi,offset Bitmap
        xor     eax,eax
        mov     [esi],eax
        call    LoadFile
        cmp     ax,-1
        jne     LBMXlat
        mov     eax,EXT_BMP
        call    FileNameExt
        mov     esi,offset Bitmap
        call    LoadFile
        cmp     ax,-1
        je      LBMExit
LBMXlat:call    TranslateBitmap
LBMExit:ret

DefaultBitmap db 'Default.Bmp',0

EndP LoadBitmap

; ***********************************************************************
; *                                                                     *
; *                  Draw a bitmap on the screen                        *
; *                                                                     *
; ***********************************************************************

DrawBitmap Proc
        push    eax ebx ecx edx edi esi
        mov     eax,[dword ptr BitMap]
        cmp     eax,0
        je      DBMExit
        xor     eax,eax
        mov     ebx,[VideoRAM]
        add     ebx,199*320
        mov     ecx,offset BitMap+1074
        mov     esi,offset TranslateBitmapTable
        mov     dh,200
DBM1:   mov     di,320
DBM2:   mov     al,[ecx]
        mov     al,[esi+eax]
        mov     [ebx],al
        inc     ecx
        inc     ebx
        dec     di
        jnz     DBM2
        sub     ebx,320*2
        dec     dh
        jnz     DBM1
DBMExit:pop     esi edi edx ecx ebx eax
        ret
EndP DrawBitmap

; ***********************************************************************
; *                                                                     *
; *                  Do the bitmap translation                          *
; *                                                                     *
; ***********************************************************************

TranslateBitmap Proc
        mov     dl,64                           ; next available translation slot
        mov     esi,offset BitMap+1074          ; byte to translate source
        mov     cx,320*200                      ; bytes to translate
        xor     eax,eax
Trans1: mov     al,[esi]                        ; get a byte.
        mov     dh,[TranslateBitmapTable+eax]   ; look at what it goes to.
        cmp     dh,0                            ; if non-zero already
        jnz     Trans2                          ; translated.
        mov     [TranslateBitmapTable+eax],dl   ; translate it to dl
        push    eax ebx ecx edx
        mov     cl,dl                           ; cl is the screen colour
        mov     eax,[dword ptr BitMap+54+eax*4] ; colour scheme for it
        call    SetVGAPalette                   ; define that palette entry
        pop     edx ecx ebx eax
        inc     dl                              ; next free screen value
Trans2: inc     esi                             ; next byte from screen
        dec     cx                              ; until the whole screen is
        jnz     Trans1                          ; done
        ret
EndP TranslateBitmap

.data
TranslateBitmapTable db 256 dup (0)
.code
end
