/**************************************************************************

							Build Fixes

  Run this program and redirect the output to fixes.inc - this generates
  the code to check and patch the fixes to various ROMs

 **************************************************************************/

#include <stdio.h>
#include <stdlib.h>

unsigned char Header[512];			/* 1/2k of Cart read here */

static char *Fixes[] =

{
	"A_SPACE.GB","C:305",			/* Altered space,cycles = 305 */
	"ALFREDCH.GB","V",				/* Alfred Chicken, VBI when off */
	"ASTEROID.GB","C:305",			/* Asteroid (Accolade) Cycles = 305 */
	"ADDAMSF.GB","E",				/* Addams Family 1 Early VBI */
	"BB1.GB","N",					/* Bubble Bobble 1 (No rec int) */
	"DAEDOPUS.GB","C:305",			/* Daedlian Opus Cycles = 305 */
	"DORAEMO2.GB","C:305",			/* Doraemon 2,Cycles = 305 */
	"FRANKTHO.GB","V",				/* Frank T Baseball,VBI when off */
	"HUDSONHA.GB","H:1",			/* Hudson Hawk hack 1 */
	"JEOPARDY.GB","E",				/* Jeopardy Early VBI */
	"HOOK.GB","E",					/* Hook Early VBI */
	"MEGAMAN5.GB","E",				/* Megaman 5 Early VBI */
	"OBELIX.GB","E",				/* Obelix Early VBI */
	"REN&STIM.GB","V",				/* Ren & Stimpy Vidiots, VBI when off */
	"ROBOCO~1.GB","E",				/* Robocop 2 Early VBI */
	"RTYPE2.GB","E",				/* R-Type 2 Early VBI */
	"SF2.GB","C:305",				/* Streetfighter 2,Cycles = 305 */
	"SUPERH~1.GB","E",				/* Super Hunchback Early VBI */
	"WAVERACE.GB","O",				/* Waverace, Or Interrupts */
	"WWF-KING.GB","V",				/* WWF King/Ring VBI when off */
	"YOGI.GB","C:305",				/* Yogi Bear Cycles = 305 */

NULL,NULL };

void main()
{
int n,i;
unsigned long l;
FILE *f;
char File[128];
i = 0;
while (Fixes[i] != NULL)
	{
	sprintf(File,"c:\\gameboy\\test\\%s",Fixes[i]);
	f = fopen(File,"rb");
	if (f == NULL) exit(fprintf(stderr,"Couldn't open '%s'\n",Fixes[i]));
	if (fread(Header,1,512,f) != 512) exit(fprintf(stderr,"Read failed.\n"));
	fclose(f);
	printf("; *** %s [",File);
	for (n = 0x134;n < 0x144;n++)
		{
		printf("%c",(Header[n] >= ' ' ? Header[n] : '.'));
		}
	printf("] ***\n");
	for (n = 0x134;n < 0x144;n = n+4)
		{
		l = *((unsigned long *)(Header+n));
		printf("    cmp [dword ptr ROMImage+0%xh],0%lxh\n",n,l);
		printf("    jne Fix%d\n",i);
		}

	switch(*(Fixes[i+1]))
		{
		case 	'C':
			printf("    mov [Mode00Cycles],%s\n",Fixes[i+1]+2);
			break;
		case 	'E':
			printf("    mov [EarlyVBI],1\n");
			break;
		case 	'N':
			printf("    mov [NoMLInterrupt],1\n");
			break;
		case	'O':
			printf("    mov [OrInt],1\n");
			break;
		case    'V':
			printf("    mov [VBIWhenOff],1\n");
			break;
		case	'H':
			printf("    mov [Hack],%s\n",Fixes[i+1]+2);
			break;
		default:
			exit(fprintf(stderr,"Unknown fix type\n"));
		}

	printf("    jmp FCDone\n");
	printf("Fix%d:\n",i);
	i = i+2;
	}
}