/************************************************************************/
/*                                                                      */
/*						Instruction Generation							*/
/*                                                                      */
/************************************************************************

Generates : 9

*/

#include "cpu.h"

void Group9(void)
{
int Op,Lbl;
static char *RotateOp[] = { "rlc a","rrc a","rl a","rr a" };

Define(0x00,4,"nop");					/* 0x00 NOP (4) No operation */
EndDefine();

Define(0x08,20,"ld (nnnn),sp");			/* 0x08 Save SP (20) */
FetchWord();
printf("    mov cx,[%s]\n",				/* only 16 bit write (not counting) */
				GetZRegName("SP"));		/* PUSH */
MemWrite("cl");
printf("    inc bx\n");
MemWrite("ch");
EndDefine();

Define(0x10,32,"stop");					/* 0x10 STOP (4) Stop CPU */
printf("    dec [%s]\n",				/* PC stays where it is */
				GetZRegName("PC"));
printf("    or [%s],080h\n",			/* Flag for 'sleep' mode */
					GetZRegName("IFF"));
EndDefine();

for (Op = 0;Op < 4;Op++)				/* 0x07,0x0F,0x17,0x1F rotates */
	{
	Define(0x07+Op*8,4,RotateOp[Op]);
	GetReg(REG_A,"al");					/* Get the value */
	Operation(Op+8);					/* Do the operation */
	PutReg(REG_A,"al");					/* Save the value */
	EndDefine();
	}

Define(0x27,4,"daa");					/* 0x27 DAA Decimal Adjust (4) */
Lbl = ClaimLabel(2);
printf("    cmp [%s],0\n",				/* last was ADD or SUB ? */
					GetZRegName("NFlag"));
printf("    jnz short %s\n",			/* use x86 DAA or DAS */
					SysLabel(Lbl));
GetReg(REG_A,"al");
LoadFlags();
printf("    daa\n");
SaveFlags();
PutReg(REG_A,"al");
printf("    jmp short %s\n",SysLabel(Lbl+1));
Label(SysLabel(Lbl));
GetReg(REG_A,"al");
LoadFlags();
printf("    das\n");
SaveFlags();
PutReg(REG_A,"al");
Label(SysLabel(Lbl+1));
EndDefine();

Define(0x2F,4,"cpl");					/* 0x2F CPL complement acc (4) */
printf("    xor [%s],255\n",GetZRegName(GetRegName(REG_A)));
SetNFlag(TRUE);
SetFlag(X86_HCARRY);
EndDefine();

Define(0x37,4,"scf");					/* 0x37 SCF Set carry flag (4) */
SetFlag(X86_CARRY);
SetNFlag(0);
ClearFlag(X86_HCARRY);
EndDefine();

Define(0x3F,4,"ccf");					/* 0x3F CCF Complement carry (4) */
printf("    xor ah,0%02xh\n",X86_CARRY);
SetNFlag(0);
EndDefine();

Define(0x76,4,"halt");					/* 0x76 HALT (4) Stop CPU */
printf("    jmp %s\n",OpLabel(0x10));
EndDefine();

Define(0xD9,16,"reti");					/* 0xD9 RETI (4) Return from Int */
Operation(O_POPCX);
printf("    mov [%s],cx\n",				/* return */
				GetZRegName("PC"));
printf("    mov al,1\n");
printf("    or [%s],al\n",				/* enable the interrupts */
				GetZRegName("IFF"));

EndDefine();

Define(0xE0,12,"ld ($FFnn),a");			/* 0xE0 Save to page FF */
Fetch("cl");              				/* Get the low byte */
printf("    mov bl,cl\n");
printf("    mov bh,255\n"); 			/* make 16 bit address */
GetReg(REG_A,"al");
MemWrite("al");							/* do the write */
EndDefine();

Define(0xE2,12,"ld ($FF00+c),a");		/* 0xE2 Save to page FF */
GetReg(REG_C,"bl");						/* get low byte */
printf("    mov bh,255\n");				/* 16 bit address */
GetReg(REG_A,"al");
MemWrite("al");							/* write it */
EndDefine();

Define(0xE8,16,"add sp,e");				/* 0xE8 Add Sp relative */
Fetch("al");
printf("    mov bx,[%s]\n",GetZRegName("SP"));
Operation(O_SEXA);
printf("    mov [%s],bx\n",GetZRegName("SP"));
EndDefine();

Define(0xE9,4,"jp (hl)");				/* 0xE9 JP (HL) */
printf("    mov bx,[word ptr %s]\n",GetZRegName("HL"));
printf("    mov [%s],bx\n",GetZRegName("PC"));
EndDefine();

Define(0xEA,16,"ld (nnnn),a");			/* 0xEA Save A */
FetchWord();
GetReg(REG_A,"al");
MemWrite("al");
EndDefine();

Define(0xF0,12,"ld a,($FFnn)");			/* 0xF0 Load from page FF */
Fetch("cl");              				/* Get the low byte */
printf("    mov bl,cl\n");
printf("    mov bh,255\n"); 			/* make 16 bit address */
MemRead("al");							/* do the read */
PutReg(REG_A,"al");
EndDefine();

Define(0xF2,12,"ld a,($FF00+c)");		/* 0xF2 Load from page FF */
GetReg(REG_C,"bl");						/* get low byte */
printf("    mov bh,255\n");				/* 16 bit address */
MemRead("al");
PutReg(REG_A,"al");
EndDefine();

Define(0xF3,4,"di");					/* 0xF3 DI (4) Disable interrupt */
printf("    and [%s],0feh\n",GetZRegName("IFF"));
EndDefine();

Define(0xF8,16,"ld hl,sp+e");			/* 0xF8 Ld hl,Sp relative */
Fetch("al");
printf("    mov bx,[%s]\n",GetZRegName("SP"));
Operation(O_SEXA);
printf("    mov [word ptr %s],bx\n",GetZRegName("HL"));
EndDefine();

Define(0xF9,4,"ld sp,hl");			/* 0xF9 Hl -> SP */
printf("    mov bx,[word ptr %s]\n",GetZRegName("HL"));
printf("    mov [%s],bx\n",GetZRegName("SP"));
EndDefine();

Define(0xFA,16,"ld a,(nnnn)");			/* 0xFA Load A */
FetchWord();
MemRead("al");
PutReg(REG_A,"al");
EndDefine();

Define(0xFB,16,"ei");					/* 0xFB EI (4) Enable interrupt */

/*
printf(" mov [ContVec],edi\n");
printf(" mov edi,offset SetIntFlag\n");
printf(" jmp [ContVec]\n");
printf("ContVec dd 0\n");
printf("SetIntFlag:\n");
printf("    or [%s],1\n",GetZRegName("IFF"));
printf(" mov edi,[ContVec]\n");
*/
printf("    or [%s],1\n",GetZRegName("IFF"));
EndDefine();
}