; ***********************************************************************
; ***********************************************************************
; *                                                                     *
; *                 Serial I/O Code, from VGB basically                 *
; *                                                                     *
; * I don't understand the serial I/O at present, so this is converted  *
; * from the code in VGB-DOS                                            *
; ***********************************************************************
; ***********************************************************************

.386p 
.model flat 
.code 
include Gb.Inc

; ***********************************************************************
; *                                                                     *
; *                 Initialise the serial I/O stuff                     *
; *                                                                     *
; ***********************************************************************

SerialReset Proc
        mov     [SIOBuf],0
        mov     [SIOFlag],0
        mov     [SIOCount],0
        mov     [byte ptr Memory+0FF01h],0
        mov     [byte ptr Memory+0FF02h],0
        ret
EndP SerialReset

; ***********************************************************************
; *                                                                     *
; *       Write to FF01,FF02. BX=Logical,ESI=Physical,CL=Data           *
; *                                                                     *
; ***********************************************************************

SerialWrite Proc
        cmp     bl,01h                  ; dispatch the writes
        je      WriteFF01
        cmp     bl,02h
        je      WriteFF02
        ret                             ; never happens.....
;
;       write to $FF01 (Serial Data)
;
WriteFF01:
        mov     [SIOBuf],cl             ; SIOBuf = Value
        or      [SIOFlag],02h           ; set bit in SIOFlag
        mov     [esi],cl                ; save the byte anyway.
        ret
;
;       write to $FF02 (serial control)
;
WriteFF02:
        mov     [SIOCount],0            ; SIOCount = 0
        test    cl,080h                 ; if bit 7 is clear,thats it
        jz      WriteFF02End
        test    cl,1                    ; if bit 1 is zero (external clock)
        jz      ClearFlagExit           ; don't reset the SIO Counter
        mov     [SIOCount],8            ; set SIO Counter to 8 bits to write
ClearFlagExit:
        and     [SIOFlag],0FDh          ; clear bit in SIO Flag
WriteFF02End:
        or      cl,07Eh                 ; or data with 7E as bits other
        mov     [esi],cl                ; than 7 or 0 are 1,and write back
        ret
EndP SerialWrite

; ***********************************************************************
; *                                                                     *
; *                     Serial Interrupt check                          *
; *                                                                     *
; ***********************************************************************

SerialInterrupt Proc

        cmp     [SIOCount],0            ; if SIO Count zero then no
        jz      SerialInterruptExit     ; interrupt can be generated.

        shl     [byte ptr Memory+0FF01h],1
        or      [byte ptr Memory+0FF01h],1

        dec     [SIOCount]              ; decrement the counter
        jnz     SerialInterruptExit     ; if it reaches zero data has gone
                                        ; clear the transmit flag.
        and     [byte ptr Memory+0FF02h],07Fh
                                        ; interrupt if its enabled
        push    eax                     ; set the interrupt flag
        mov     al,8
        call    RaiseInterrupt
        pop     eax
SerialInterruptExit:
        ret
EndP SerialInterrupt
end
